<?php

/**
 * Generates checkboxes, for group => values => checked/unchecked structures,
 * wrapping each group in a fieldset.
 *
 * @param array $data The data to create the checkboxes for.
 * @return string The generated checkboxes.
 */
function generateCheckboxes($data) {
    $checkboxes = '';

    foreach ($data as $group => $values) {
        $fieldset = $values['fieldset'];
        $options = $values['options'];
        $checkboxes .= '<fieldset>';
        $checkboxes .= "<legend>$fieldset</legend>";

        foreach ($options as $option => $checked) {
            $checked = ($checked) ? 'checked' : '';

            $checkboxes .= '<div>';
            $checkboxes .= "<input type='checkbox' name='$group" . '[]' . "' id='$option' value='$option' $checked>";
            $checkboxes .= "<label for='$option'>$option</label>";
            $checkboxes .= '</div>';
        }

        $checkboxes .= '</fieldset>';
    }

    return $checkboxes;
}

// Flow starts here.

$programmingLanguages = [
    'programming-languages' => [
        'fieldset' => 'Programming languages you have worked with',
        'options' => [
            'Python' => false,
            'PHP' => true,
            'Haskell' => false,
            'Other' => false
        ]
    ]
];

$checkboxes = generateCheckboxes($programmingLanguages);

echo $checkboxes;

echo 'Generated HTML code:<br>';
echo "<xmp>$checkboxes</xmp>";
