<?php

/**
 * Checks if the given parameters are set. If one of the specified parameters
 * is not set, die() is called.
 *
 * @param $parameters The parameters to check.
 */
function checkGETParametersOrDie($parameters) {
    foreach ($parameters as $parameter) {
        isset($_GET[$parameter]) || die("'$parameter' parameter must be set.");
    }
}

/**
 * Print the submitted data. If the value is an array, is imploded to a string.
 *
 * @param array $data The form data, with $name => $value format.
 */
function printData($data) {
    echo 'You have submitted the form with the following data:<br>';
    echo '<ul>';

    foreach ($data as $name => $value) {
        echo "<li>$name: ";

        if (is_array($value)) {
            $value = implode(', ', $value);
        }

        echo "<b>$value</b>";
        echo '</li>';
    }

    echo '</ul>';
}

// Flow starts here.

checkGETParametersOrDie([
    'name',
    'programming-languages'
]);

$name = $_GET['name'];
$programmingLanguages = $_GET['programming-languages'];

printData([
    'Name' => $name,
    'Programming languages you have worked with' => $programmingLanguages
]);
